<?php
/*------------------------------------------------------------------------
# Joomla News Show Module V1 by JoomShaper.com
# ------------------------------------------------------------------------
# author    JoomShaper http://www.joomshaper.com
# copyright Copyright (C) 2010 JoomShaper.com. All Rights Reserved.
# @license - Copyrighted Commercial Software
# Websites: http://www.joomshaper.com - http://www.joomxpert.com
# This file may not be redistributed in whole or significant part
-------------------------------------------------------------------------*/

// no direct access
defined('_JEXEC') or die('Restricted access');

require_once (JPATH_SITE.DS.'components'.DS.'com_content'.DS.'helpers'.DS.'route.php');

class modJoomAS1Helper
{
	function loadStyles(&$module, &$params)
	{
		$uniqid					= $params->get('uniqid', '1');
		$ns1_padding			= $params->get('ns1_padding', '3');
		
		$document = & JFactory::getDocument();
		
		if ($params->get( 'layout','style1' )=='style1') {
			$style = '#joom_ns1_id' . $uniqid . ' .ns1-padding {padding:' .$ns1_padding. 'px;}';
		} elseif ($params->get( 'layout','style1' )=='style2') {
			$style = '#joom_ns1_id' . $uniqid . ' .ns1-padding {padding:' .$ns1_padding. 'px;}
			#joom_ns1_id' . $uniqid . ' .datebox {display:block;height: auto;text-align:center;margin:8px 10px 10px 0;float:left;}
			#joom_ns1_id' . $uniqid . ' .date_month {font-size:9px;font-weight:bold;margin-left:1px;margin-top:2px;text-transform:uppercase;}
			#joom_ns1_id' . $uniqid . ' .date_day {display:block;font-size:22px;font-weight:bold;margin-bottom:0;}';
		}
		$document->addStyleDeclaration( $style );
	}
		
	function getList(&$params)
	{
		global $mainframe;
		
		$db 	        = &JFactory::getDBO();
		$user		    = &JFactory::getUser();
		$userId			= (int) $user->get('id');
		
		$count		    = $params->get('article_count',3); 
		$catid		    = trim( $params->get('catid') );
		$secid		    = trim( $params->get('secid') );
		$show_front	    = $params->get('show_front', 1);
		$aid		    = $user->get('aid', 0);

		$ordering       = $params->get('itemsOrdering');
		$user_id        = $params->get('user_id');
		
		$contentConfig = &JComponentHelper::getParams( 'com_content' );
		$access		= !$contentConfig->get('show_noauth');

		$nullDate	    = $db->getNullDate();

		$date =& JFactory::getDate();
		$now = $date->toMySQL();
		$where = '';
		
		// User Filter
		switch ($user_id)
		{
			case 'by_me':
				$where .= ' AND (a.created_by = ' . (int) $userId . ' OR a.modified_by = ' . (int) $userId . ')';
				break;
			case 'not_me':
				$where .= ' AND (a.created_by <> ' . (int) $userId . ' AND a.modified_by <> ' . (int) $userId . ')';
				break;
		}
		// ensure should be published
		$where .= " AND ( a.publish_up = ".$db->Quote($nullDate)." OR a.publish_up <= ".$db->Quote($now)." )";
		$where .= " AND ( a.publish_down = ".$db->Quote($nullDate)." OR a.publish_down >= ".$db->Quote($now)." )";
		
	    // ordering
		switch ($ordering) {
			case 'date' :
				$orderby = 'a.created ASC';
				break;
			case 'rdate' :
				$orderby = 'a.created DESC';
				break;
			case 'alpha' :
				$orderby = 'a.title';
				break;
			case 'ralpha' :
				$orderby = 'a.title DESC';
				break;
			case 'hits' :
				$orderby = 'a.hits DESC';
				break;
			case 'order' :
				$orderby = 'a.ordering';
				break;
			default :
				$orderby = 'a.id DESC';
				break;
		}
		
		$catCondition = '';
		$secCondition = '';

		if ($show_front != 2) {
			if ($catid)
			{
				$ids = explode( ',', $catid );
				JArrayHelper::toInteger( $ids );
				$catCondition = ' AND (cc.id=' . implode( ' OR cc.id=', $ids ) . ')';
			}
			if ($secid)
			{
				$ids = explode( ',', $secid );
				JArrayHelper::toInteger( $ids );
				$secCondition = ' AND (s.id=' . implode( ' OR s.id=', $ids ) . ')';
			}
		}

		// Content Items only
		$query = 'SELECT a.*, ' .
			' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'.
			' CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":", cc.id, cc.alias) ELSE cc.id END as catslug'.
			' FROM #__content AS a' .
			($show_front == '0' ? ' LEFT JOIN #__content_frontpage AS f ON f.content_id = a.id' : '') .
			($show_front == '2' ? ' INNER JOIN #__content_frontpage AS f ON f.content_id = a.id' : '') .
			' INNER JOIN #__categories AS cc ON cc.id = a.catid' .
			' INNER JOIN #__sections AS s ON s.id = a.sectionid' .
			' WHERE a.state = 1'. $where .' AND s.id > 0' .
			($access ? ' AND a.access <= ' .(int) $aid. ' AND cc.access <= ' .(int) $aid. ' AND s.access <= ' .(int) $aid : '').
			($catid && $show_front != 2 ? $catCondition : '').
			($secid && $show_front != 2 ? $secCondition : '').
			($show_front == '0' ? ' AND f.content_id IS NULL ' : '').
			' AND s.published = 1' .
			' AND cc.published = 1' .
			' ORDER BY '. $orderby;
			
		$db->setQuery($query, 0, $count);
		$rows = $db->loadObjectList();	
		
		$i=0;
		$lists	= array();
		
		if (is_array($rows) && count($rows)>0) {
    		foreach ( $rows as $row )
    		{
    		    $text = $row->introtext;
    			$lists[$i]->id = $row->id;
    			$lists[$i]->date = $row->created;				
    			$lists[$i]->image_name = modJoomAS1Helper::getImage($text);
    			$lists[$i]->title = modJoomAS1Helper::getTitle($row->title,$params);
    			$lists[$i]->introtext = modJoomAS1Helper::clearText($text,$params);				
				$lists[$i]->link = JRoute::_(ContentHelperRoute::getArticleRoute($row->slug, $row->catslug, $row->sectionid));
    			$i++;
    		}
        }
		return $lists;
	}
	
	function getTitle($text,$params) {
		if($params->get( 'limit_title',0 )==1) {
			$chars_limit 		= $params->get('title_char_limit', "20");
			$cleanWords			= htmlspecialchars($text);
			$text				= substr($cleanWords, 0, $chars_limit);
		}else {
			$text				= htmlspecialchars($text);
		}
		return $text;
	}

	function clearText($text,$params) {
		$words_limit 		= $params->get('word_limit', "40");
		$cleanWords			= & JFilterOutPut::cleanText($text);
		$words 				= explode(' ', $cleanWords);
		$text				= implode(' ', array_slice($words, 0, $words_limit));	
		return $text;
	}

	function getImage($text) {
		$imgsrc 			= '/\<img.+?src=\"(.+?)\".+?\/>/'; 
		preg_match($imgsrc, $text, $match);
		if ($match) {
			$image_name		=$match[1];
		} else {
			$image_name		= null;
		}
		return $image_name;
	}
}
 